// BoundingBox.h: interface for the CBoundingBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BOUNDINGBOX_H__913474D9_06B5_4A94_85AA_C22307232FF3__INCLUDED_)
#define AFX_BOUNDINGBOX_H__913474D9_06B5_4A94_85AA_C22307232FF3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Maths.h"
#include "Material.h"

class CBoundingBox  
{
public:

	void Calculate(CVector min, CVector max);
	CVector GetVertex(unsigned int x, unsigned int y, unsigned int z);

	virtual void Draw();
	
	__inline void Hide()
	{ m_bVisible = false; };

	__inline void Show()
	{ m_bVisible = true; };

	__inline bool Visible()
	{ return m_bVisible; };

	__inline void SetRenderMode(unsigned int mode)
	{ m_iRenderMode = mode; };

	__inline unsigned int GetRenderMode()
	{ return m_iRenderMode; };

	CBoundingBox();
	virtual ~CBoundingBox();

	void Evaluate(CVector *vertices, int count, CMatrix *mdl_matrix);
	void Evaluate(tBoneVertex *vertices, int count, CMatrix *mdl_matrix);
	void Evaluate(tVERTEX3f *vertices, int count, CMatrix *mdl_matrix);

	bool PointInBox(CVector vec);

	CMatrix *m_pMdlMatrix;
	RGBA	m_Color;

private:
	bool m_bVisible;
	unsigned int m_iRenderMode;

	CVector m_Min, m_Max;
	CVector m_Vert[8];
};

#endif // !defined(AFX_BOUNDINGBOX_H__913474D9_06B5_4A94_85AA_C22307232FF3__INCLUDED_)
